#include "rollitwidget.h"

#include <QtGui>

#include "rollitwidget.h"

RollitWidget::RollitWidget(QWidget *parent)
    : QWidget(parent)
{
    setAcceptDrops(true);
    setMinimumSize(640, 640);
    setMaximumSize(640, 640);
    gameBeg=0;

    b1=new board();

    b1->board_tab[3][3]=1;
    b1->board_tab[3][4]=2;
    b1->board_tab[4][3]=2;
    b1->board_tab[4][4]=1;



}

void RollitWidget::clear()
{
    pieceLocations.clear();
    piecePixmaps.clear();
    pieceRects.clear();
    highlightedRect = QRect();
    inPlace = 0;
    update();
}

void RollitWidget::dragEnterEvent(QDragEnterEvent *event)
{
    if (event->mimeData()->hasFormat("image/x-puzzle-piece"))
        event->accept();
    else
        event->ignore();
}

void RollitWidget::dragLeaveEvent(QDragLeaveEvent *event)
{
    QRect updateRect = highlightedRect;
    highlightedRect = QRect();
    update(updateRect);
    event->accept();
}

void RollitWidget::dragMoveEvent(QDragMoveEvent *event)
{
    QRect updateRect = highlightedRect.unite(targetSquare(event->pos()));

    if (event->mimeData()->hasFormat("image/x-puzzle-piece")
        && findPiece(targetSquare(event->pos())) == -1) {

        highlightedRect = targetSquare(event->pos());
        event->setDropAction(Qt::MoveAction);
        event->accept();
    } else {
        highlightedRect = QRect();
        event->ignore();
    }

    update(updateRect);
}

void RollitWidget::dropEvent(QDropEvent *event)
{
    if (event->mimeData()->hasFormat("image/x-puzzle-piece")
        && findPiece(targetSquare(event->pos())) == -1) {


        if (gameBeg==0) gameBeg++;
        QByteArray pieceData = event->mimeData()->data("image/x-puzzle-piece");
        QDataStream dataStream(&pieceData, QIODevice::ReadOnly);
        QRect square = targetSquare(event->pos());
        QRect all(0,0,640,640);

        QPoint cent=square.center();

        int x=cent.x()/80;
        int y=cent.y()/80;

        qDebug() << "col:" << x;
        qDebug() << "row:" << y;

        b1->board_tab[x][y]=1;
        QString str=b1->place(x,y);
        b1->setFreePos(str);



        b1->ProcessHV(x,y);


        b1->processDiag(x,y);

        QPixmap pixmap;
        QPoint location;
        dataStream >> pixmap >> location;

        pieceLocations.append(location);
        piecePixmaps.append(pixmap);
        pieceRects.append(square);

        highlightedRect = QRect();
        update(square);
        update(all);

        event->setDropAction(Qt::MoveAction);
        event->accept();

        if (location == QPoint(square.x()/80, square.y()/80)) {
            inPlace++;
          }
    } else {
        highlightedRect = QRect();
        event->ignore();
    }

   b1->playIA();






}

int RollitWidget::findPiece(const QRect &pieceRect) const
{


    if (gameBeg==0) { if ((pieceRect.intersects(QRect(160,160,320,320)))&&(!pieceRect.intersects(QRect(240,240,160,160)))) {  return -1; } }
    else {


        QPoint x1=pieceRect.topLeft();
        int bposX=x1.x()/80;
        int bposY=x1.y()/80;


        if (b1->board_tab_free[bposX][bposY]==0) {

          if(b1->board_tab[bposX][bposY]==0) return -1; else return 1;


        }
          else return 1;


}
}

void RollitWidget::mousePressEvent(QMouseEvent *event)
{


}

void RollitWidget::paintEvent(QPaintEvent *event)
{
    QPainter painter;
    painter.begin(this);
    painter.drawPixmap(0,0,QPixmap("checker.png"));



    for(int i=0;i<8;i++)
    {
        for(int j=0;j<8;j++)
        {
            if (b1->board_tab[i][j]==1) painter.drawPixmap(0+i*80,0+j*80,QPixmap("pion_vert.png"));
            if (b1->board_tab[i][j]==2) painter.drawPixmap(0+i*80,0+j*80,QPixmap("pion_jaune.png"));

        }
    }



    if (highlightedRect.isValid()) {
        painter.setBrush(QColor("#ffcccc"));
        painter.setPen(Qt::NoPen);
        painter.drawRect(highlightedRect.adjusted(0, 0, -1, -1));
    }

    for (int i = 0; i < pieceRects.size(); ++i) {
        painter.drawPixmap(pieceRects[i], piecePixmaps[i]);
    }
    painter.end();
}

const QRect RollitWidget::targetSquare(const QPoint &position) const
{
    return QRect(position.x()/80 * 80, position.y()/80 * 80, 80, 80);
}



